

DEFINE CLASS base_maurice AS custom && normalement dans STANDARD_MAURICE
  * classe business object de base
  versionbase = ""
  datebase = {^2003.03.18}
  erreur = -1                && -1 non initialis
  fvfpmou = ""  && intitul de la classe pour VFPMOU
  vfpmou = .F.  && .T. si vfpmou ouvert jme 29/12/2005
  
  * partie programmes de l'objet (de la classe) eleve
  PROCEDURE init
    DODEFAULT()
    This.vfpmou = USED("VFPMOU")    && jme 29/12/2005
  ENDPROC
ENDDEFINE && CLASS base_maurice AS custom

  
DEFINE CLASS banques AS base_maurice && jme 05/01/2006
  * classe d'accs  la table demo!banques
  * il n'y a aucune rgle de validit, d'intgrit rferentielle, aucun trigger sur cette
  * table dans la base de donnes.
  *  (le fait de mettre les vrifications dans cette classe plutt que dans la bdd me
  *   me donne une dtection d'erreur beaucoup plus fine en cas de problme; en particulier
  *   le mouchard)
  * cette table contient la listes des banques. Cette liste est utilise pour reprer les
  * rglements et pour classer les remises en banques.
  * Plus tard on envisage la gestion des agences. C'est pourquoi les codes banques dans
  * la table paiements sont sur 4 caractres (2 pour la banque et 2 pour l'agence).
  
*!	  Champ     Nom de champ      Type         Largeur  Dc Index   Collate      Valeurs nulles
*!	      1     CODE              Caractre          2      Crois.   Machine          Non
*!              contient une valeur binaire (donc BINTOC()).
*!              cette valeur est positive si la ligne est valide. ngative sinon.
*!              on n'utilise pas DELETE sur cette table
*!	      2     ABREV             Caractre          4      Crois.   Machine          Non
*!              abrviation de la banque (CA pour Crdit Agricole). Doit tre unique.
*!	      3     NOM               Caractre         40      Crois.   Machine          Non
*!              nom de la banque. Doit tre unique.
*!	      4     IBAN              Caractre         35      Non
*!              non utilis pour l'instant
*!	      5     BIC               Caractre          8      Non
*!              non utilis pour l'instant
*!	      6     FREQUENCE         Entier             4      Dcr.   Machine          Non
*!              valeur numrique calcule de temps en temps. Reprsente le nombre "d'apparition"
*!              de la banque dans la table des paiements. Sert juste  mettre les banques les
*!              plus frquentes en dbut de liste dans les combos.
*!	      7     CREAT             DateHeure          8      Non
*!              datetime de dernire modification

*!	 ** Total **                                       102
*!	Page de code: 1252  (attention la table des paiements est en 850)
*!	TAG:   CODE       Copies assembles:   Machine    Cl CODE Candidat
*!	TAG:   ABREV      Copies assembles:   Machine    Cl ABREV
*!	TAG:   NOM        Copies assembles:   Machine    Cl NOM
*!	TAG:   FREQUENCE  Copies assembles:   Machine    Cl FREQUENCE      (Dcroissant)
  * pour les codes vnement de vfpmou (le mouchard) la tranche est : 70200-70299
  
  nombre_banques = 0      && nombre de banques dans la table
  ya_modif = .F.          && .T. si l'image de l'enregistrement a t modifie
  image = NULL            && image de travail 'scatter name' de banques
  image_old = NULL        && image scatter name de l'original de l'enreg de banques
                          && en comparant .image et .image_old on peut savoir s'il y a eut des
                          && modifications, abandonner les modifications en cours, ...
  alias_liste = ""        && nom du curseur contenant la liste des banques
  alias_combo = ""        && nom du curseur utilis comme controlsource des combobox
  *                          de slection. Idem alias_liste mais avec en premier 'aucune' et
  *                          en dernier "la banque n'est pas dans la liste"
  alias_banques = ""      && alias local de la table banques
  alias_une_banque = ""   && alias local de la vue demo!banques_un_rw
  alias_paiement = ""     && alias local de la table paiement
  alias_listpai_1bq = ""  && alias local liste des paiements d'une banque

  * partie programmes de l'objet (de la classe) banques
	* PROCEDURE maintenance() : vrification, correction des anomalies, reindexation
	* FUNCTION enregistrer() fonction peu utile. ya_modif doit tre .T.
	*                        l'image doit tre  jour. La clef peut tre nulle (ajout)
  * FUNCTION ajouter()     ajouter. traite la clef. ya_modif quelconque. 
  *                        l'image doit tre  jour sauf pour la clef. 
  *                        Fonction  utiliser pour ajouter
  * FUNCTION modifier()    modifier. ya_modif quelconque.
  *                        Fonction  utiliser pour modifier
  * FUNCTION supprimer()   supprime la banque prsente dans image. ya_modif quelconque.
  * FUNCTION chercher(codebanque C(2)) && cherche une banque et retourne l'image correspondante
  * FUNCTION rechercher(codebanque C(2)) && cherche une banque SANS retourner l'image correspondante
  *                                         (recherche rapide)
  * FUNCTION positionnement_combo(codebanque C(2 ou 4)) && selectionne la banque 
  *                        dans alias_combo et retourne son recno(). codebanque peut tre sur 4 car.
  * PROCEDURE calcul_frequence  mise  jour du champ frequence de la table banques pour 
  *                             pouvoir slectionner plus facilement les banques dans les
  *                             comboboxes en les mettant par ordre de frquence dcroissant
  * PROCEDURE liste_banques_cheques : liste des chques remis  une banque donne ou  toutes 
  *                                   les banques le tout pour une priode donne
  
  HIDDEN PROCEDURE init
    LOCAL lcnom, lccode
    
    DODEFAULT()         && met  jour .vfpmou
    WITH This
	    .erreur = -1      && -1 non initialis, 0 non trouv, 1 ok
	    .versionbase = "1.0"
	    .datebase = {^2006.01.09}      && date de cration de cette classe
	    .fvfpmou = "demo_banques.banques"  && intitul de la classe pour VFPMOU
	    * dans toutes mes applications, il y a un mouchard qui s'appelle VFPMOU et dans lequel
	    * on enregistre toutes les oprations faites. C'est, en gnral, la plus grosse 
	    * table de l'application.
	    IF .vfpmou && mis  jour dans la classe parent
			  INSERT INTO vfpmou VALUE (DATE(), SECONDS(), 70200, "init", This.fvfpmou, ;
			   "init "+TIME(), "", "", 0)
			  * avec ce mouchard je peux connaitre tout ce qu'il s'est pass dans l'application :
			  * par ordre chronologique, par code (ici la tranche 70200-70299 concerne cette classe) ...
	    ENDIF && This.vfpmou
      .alias_banques = "bq"+SYS(2015)
      .alias_liste = "bl"+SYS(2015)
      .alias_combo = "bc"+SYS(2015)
      * l'utilisation d'une chaine suivie de SYS(2015) donne un nom valide unique; de plus
      * ce nom est facilement reconnaissable dans le code de la classe (bq = banque, 
      * bl = banque liste, ...)
      * on peut instancier cette classe plusieurs fois sans interference.
      .ouvertures()
			.erreur = 1 && ok l'initialisation est termine
    ENDWITH  && This
  ENDPROC
  
  HIDDEN PROCEDURE destroy 
    *  la destruction de l'objet cr  partir de cette classe on ferme les tables ouvertes
    * dans l'init. C'est un bon moyen de simuler l'environnement de donnes priv
    WITH This
	    IF .vfpmou
			  INSERT INTO vfpmou VALUE (DATE(), SECONDS(), 70299, "destroy", This.fvfpmou, ;
			   "destroy "+TIME(), "", "", 0)
	    ENDIF && This.vfpmou
	    * si la dernire banque traite n'est pas enregistre, on le fait (si on ne veut pas
	    * il suffit de remettre ya_modif  .F. avant de dtruire l'objet
	    IF .ya_modif
	      .enregistrer()
	    ENDIF && This.ya_modif
	    * on vrifie que toutes les tables ouvertes par cet objet soient bien ferme  sa destruction
	    * astuce (dans une autre classe j'ai eut  maintenir une vue ouverte aprs la destruction
	    * de l'objet) : si on remet  blanc le nom d'une table ou d'une vue, on ne la referme pas
	    *  la destruction de l'objet.
	    .fermetures()
    ENDWITH  && This
  ENDPROC
  
  HIDDEN PROCEDURE ouvertures
    WITH This
	    USE demo!banques AGAIN SHARED ALIAS (.alias_banques) IN 0 && banques.code = C(2)
	    * dans la table banques les codes doivent commencer aprs BINTOC(10) car on peut
	    * avoir besoin des codes de 1 (aucune banque), 2 la banque n'est pas dans la liste, ...
	    SELECT 0
			USE demo!banques_liste ALIAS (.alias_liste)
			* chaque fois que j'utilise une vue, je met son code; cela m'vite de le rechercher dans
			* la base de donnes.
			*!		CREATE SQL VIEW "BANQUES_LISTE" ;
			*!		 AS SELECT code, abrev, nom, iban, bic, frequence ;
			*!		  FROM banques WHERE CTOBIN(code) > 0 ORDER BY frequence DESC
	    .nombre_banques = RECCOUNT()
	    INDEX ON code TAG code
	    SCATTER NAME .image BLANK && initialisation des images
	    SCATTER NAME .image_old BLANK
			SELECT 0
			CREATE CURSOR (.alias_combo) (banque C(35), code C(2))
			INSERT INTO (.alias_combo) VALUES("aucune", BINTOC(1,2))
			SELECT (.alias_liste)
			SCAN ALL
			  lcnom = nom
			  lccode = code && rappel tous les codes valides sont > 10
			  INSERT INTO (.alias_combo) VALUES (m.lcnom, m.lccode)
			ENDSCAN && ALL
			INSERT INTO (.alias_combo) VALUES("la banque n'est pas dans la liste", BINTOC(2,2))
    ENDWITH  && This
  ENDPROC && ouvertures
  
  HIDDEN PROCEDURE fermetures
    * si par hasard, on a besoin de conserver la table et/ou les vues ouvertes aprs le
    * destroy de l'objet, il n'y a qu' remettre  blanc la proprit correspondante
    WITH This
	    IF !EMPTY(.alias_banques)
	      USE IN (SELECT(.alias_banques))
	    ENDIF
	    IF !EMPTY(.alias_combo)
	      USE IN (SELECT(.alias_combo))
	    ENDIF
	    IF !EMPTY(.alias_liste)
	      USE IN (SELECT(.alias_liste))
	    ENDIF
	    IF !EMPTY(.alias_paiement)
	      USE IN (SELECT(.alias_paiement))
	    ENDIF
	    IF !EMPTY(.alias_listpai_1bq)
	      USE IN (SELECT(.alias_listpai_1bq))
	    ENDIF
    ENDWITH  && This
  ENDPROC && fermetures
  
  PROCEDURE maintenance()
    * vrification de la table, correction des anomalies, reindexation
    * vrification de la clef dans la table clefs
    
    LOCAL lnaccu, lcproc, lnreccount, lncleftable, lcoldsafety
    
    lcproc = "maintenance"
    WITH This
	    IF .vfpmou
			  INSERT INTO vfpmou VALUE (DATE(), SECONDS(), 70230, m.lcproc, .fvfpmou, ;
			   TIME(), "", "", 0)
	    ENDIF && This.vfpmou
      .fermetures()
      * on tente d'ouvrir la table banques en exclusif. Si ok on continue, sinon on abandonne
      SELECT 0
      USE banques EXCLUSIVE && provisoirement on ne trap pas l'erreur. 
      * Cette classe est en VFP6 donc pas de TRY CATCH !
      IF USED("banques")    
			  * banques fait partie de la bdd demo
			  * dans paiment, le codebanque fait 4 car : 2 pour le code banque et 2
			  * pour un ventuel futur code agence
		    * la table banques a un index candidat (mais non primaire) et VFP pose la question
		    * voulez-vous le dtruire !
		    lcoldsafety = SET("SAFETY")
		    SET SAFETY OFF
		    DELETE TAG ALL
		    IF m.lcoldsafety == "ON"
		      SET SAFETY ON
		    ENDIF && m.lcoldsafety == "ON"
		    lnaccu = 0
			  LOCATE FOR DELETED()
			  IF FOUND()
			    * ne devrait jamais arriver
				  IF .vfpmou
					  INSERT INTO vfpmou VALUE (DATE(), SECONDS(), 70231, m.lcproc, .fvfpmou, ;
					   "banques DELETED "+banques.abrev+" "+banques.nom, "", "", CTOBIN(banques.code))
				  ENDIF && .vfpmou
			  ENDIF && FOUND()
			  LOCATE FOR ISBLANK(code)
			  IF FOUND()
			    * cela arrive sur les checs de tableupdate. Il faut l'enlever  cause de 
			    * l'index candidat 'code'
			    DELETE REST FOR ISBLANK(code)
			    lnaccu = _TALLY
				  IF .vfpmou
					  INSERT INTO vfpmou VALUE (DATE(), SECONDS(), 70232, m.lcproc, .fvfpmou, ;
					   "au moins 1 ligne BLANK", "", "", m.lnaccu)
				  ENDIF && .vfpmou
			  ENDIF && FOUND()
			  LOCATE FOR CTOBIN(code) < 0
			  IF FOUND()
			    * les lignes dont le code est ngatif sont  supprimer (on emploie pas DELETE)
			    DELETE REST FOR CTOBIN(code) < 0
			    lnaccu = _TALLY
				  IF .vfpmou
					  INSERT INTO vfpmou VALUE (DATE(), SECONDS(), 70233, m.lcproc, .fvfpmou, ;
					   "suppresion code<0", "", "", m.lnaccu)
				  ENDIF && .vfpmou
			  ENDIF && FOUND()
			  PACK
		    INDEX ON code TAG code CANDIDAT
		    INDEX ON abrev TAG abrev
		    INDEX ON nom TAG nom
		    INDEX ON frequence TAG frequence DESCENDING
		    * vrification de la table clefs
		    * cette table contient une ligne par table de la bdd. Elle contient la dernire
		    * valeur utilise pour chaque clef candidate ou primaire.
		    * cette vrification n'est faite que si la table clefs est ouverte
		    * (on ne tente pas de l'ouvrir ici) car cette table est forcment utilise dans 
		    * toute l'application;
		    * de mme on suppose que soit son ouverture est exclusive (on appelle cette mthode
		    *  partir d'une procdure de reindexation qui exige l'ouverture exclusive de
		    * toutes les tables) soit c'est une appli monoposte.
		    * NOTE : banques tant ouverte en exclusif, il y a peu de chances qu'un autre
		    *        poste accde  l'enregistrement correspondant  banques dans la table clefs !!
        IF USED("clefs")
				  lnreccount = RECCOUNT()
				  SET ORDER TO code
				  GO BOTTOM
				  * les codes 0  10 sont rservs 
				  * (aucune banque, la banque n'est pas dans la liste, ...
				  lncleftable = IIF(lnreccount=0, 11, CTOBIN(code))
				  IF SEEK("banques", "clefs", "alias")
				    IF lnreccount = 0
						  IF .vfpmou
							  INSERT INTO vfpmou VALUE (DATE(), SECONDS(), 70234, m.lcproc, .fvfpmou, ;
							   "demo!banques.dbf vide", "", "", 0)
						  ENDIF && .vfpmou
				      SELECT clefs && ouvert en exclusif
				      REPLACE derclefn WITH 11, date WITH datetime()
				    ELSE
					    IF clefs.derclefn >= lncleftable
							  IF .vfpmou
								  INSERT INTO vfpmou VALUE (DATE(), SECONDS(), 70235, m.lcproc, .fvfpmou, ;
								   "demo!banques OK", "", "", clefs.derclefn)
							  ENDIF && .vfpmou
					    ELSE
							  IF .vfpmou
								  INSERT INTO vfpmou VALUE (DATE(), SECONDS(), 70236, m.lcproc, .fvfpmou, ;
								   "pb clef banques anc", "", "", clefs.derclefn)
								  INSERT INTO vfpmou VALUE (DATE(), SECONDS(), 70236, m.lcproc, .fvfpmou, ;
								   "pb clef banques nouv", "", "", m.lncleftable+1)
							  ENDIF && .vfpmou
					      SELECT clefs
					      REPLACE derclefn WITH lncleftable+1, date WITH datetime() && + 1 scurit
					    ENDIF && derclefn <= lncleftable
				    ENDIF && lnreccount() = 0
				  ELSE
					  IF .vfpmou
						  INSERT INTO vfpmou VALUE (DATE(), SECONDS(), 70237, m.lcproc, .fvfpmou, ;
						   "banques : 0 enreg dans clefs", "", "", m.lncleftable)
					  ENDIF && .vfpmou
				  	SELECT clefs
				  	APPEND BLANK
				  	REPLACE alias WITH "banques", table WITH "banques.dbf", ;
				  	 date WITH datetime(), coun WITH "E", derclefn WITH lncleftable
				  ENDIF && SEEK("banques", "clefs")
        ENDIF && USED("clefs")
        USE IN banques
      ENDIF && USED("banques")
      * on rouvre la table et les vues en utilisant les mmes alias que dans l'init
      .ouvertures()
    ENDWITH  && This
  ENDPROC && maintenance
  
  FUNCTION enregistrer
    * l'image doit tre  jour. La clef peut tre nulle (ajout)
    * l'enregistrement se fait en deux temps :
    *  1) on met  jour la vue banques_une_rw  partir de l'image
    *  2) on fait un tableupdate de cette vue
    * NOTE : on a trs rarement  ajouter ou modifier une banque par rapport au nombre
    *        de fois o on utilise la liste. Il n'y a donc aucune raison d'extraire une
    *        banque lors de chaque slection. De plus toutes les vues (sauf celle ci-dessous)
    *        ont sendupdate = .F. Il faut donc, si on veut enregistrer une banque, commencer
    *        par mettre  jour la seule vue sendupdate = .T. concernant les banques.
    LOCAL llresult, lnaccu, lccode
    
    IF This.ya_modif
      this.alias_une_banque = "b1"+SYS(2015) && alias local de la vue demo!banques_un_rw    
      IF CTOBIN(This.image.code) < 10
        * on ajoute : calcul de la nouvelle clef
				* dans ma BDD, j'ai une table "clefs" qui contient une ligne par table; chaque ligne
				* contient la valeur de la dernire clef utilise pour la cration de la table 
				* correspondante. Cette table clef sera aussi utilise, plus tard, pour tenter de
				* rcuprer les enregistrements marqus pour l'effacement (pour banques en mettant
				* un code ngatif).
				llresult = .F.
				IF USED("clefs")
				  SELECT clefs
				  IF SEEK("banques", "clefs", "alias")
				    IF RLOCK("clefs")
				      lnaccu = clefs.derclefn + 1
				      REPLACE clefs.derclefn WITH m.lnaccu, clefs.date WITH DATETIME()
				      UNLOCK IN clefs
				      STORE BINTOC( m.lnaccu,2) TO this.image.code, lccode
				      llresult = .T.
				      SELECT 0
				      USE demo!banques_une_rw ALIAS (this.alias_une_banque) NODATA
*!								CREATE SQL VIEW "BANQUES_UNE_RW" ; 
*!								 AS SELECT * FROM demo!banques WHERE code = ?lccode
				      APPEND BLANK
				      GATHER NAME This.image MEMO
				    ENDIF && RLOCK()
				  ELSE
				  	WAIT WINDOW "pas de ligne pour banques dans clefs" NOWAIT
				  ENDIF && SEEK("telfaxmail")
				ELSE
					WAIT WINDOW "table des clefs non ouverte" NOWAIT
				ENDIF && USED(clefs)
      ELSE
        * on a dj une clef : modification
        llresult = .T.
        lccode = this.image.code
	      SELECT 0
	      USE demo!banques_une_rw ALIAS (this.alias_une_banque)
*!				CREATE SQL VIEW "BANQUES_UNE_RW" ; 
*!				 AS SELECT * FROM demo!banques WHERE code = ?lccode
	      GATHER NAME This.image MEMO
      ENDIF && CTOBIN(This.image.code) < 10
      IF m.llresult
        LOCAL llok, lcaccu
        LOCAL ARRAY lterr2(1), ltparm(10)
        REPLACE creat WITH DATETIME()
        * on enregistre la vue dans la table
			  llok = TABLEUPDATE(0, .F., this.alias_une_banque, lterr2)
			  * 0 : un seul enregistrement  .F. : on ne force pas en cas de conflit
			  * lterr2 tableau pour les recno()  problmes
			  IF llok
			    IF This.vfpmou
					  INSERT INTO vfpmou VALUE (DATE(), SECONDS(), 70202, "enregistrer", This.fvfpmou, ;
					   "tableupdate ok "+This.image.code + " "+ ALLTRIM(this.image.nom), "", "", 0)
			    ENDIF && This.vfpmou
			    This.ya_modif = .F.
			  ELSE
			    * on a un problme avec le tableupdate. L'oprateur va en tre averti par la fonction
			    * gnrale traitement_erreur_tableupdate. Mais comme il ne pensera pas  noter
			    * le message pour me le dire, je moucharde l'vnement pour tre capable, plus
			    * tard de retrouver le problme.
			    .erreur = -10 && utilisable dans la 'procdure appelante'
			    IF This.vfpmou
					  INSERT INTO vfpmou VALUE (DATE(), SECONDS(), 70203, "enregistrer", This.fvfpmou, ;
					   "tableupdate NAK "+This.image.code + " "+ ALLTRIM(this.image.nom), "", "", 0)
			    ENDIF && This.vfpmou
			    ltparm(1) = "BANQUES"
			    STORE "" TO ltparm(2), ltparm(3), ltparm(4), ltparm(5), ltparm(6), ltparm(7)
			    * lcaccu = traitement_erreur_tableupdate( lterr2, ltparm)
			    * le tablerevert () est fait dans traitement_erreur_tableupdate
			    * DANS L'APPLICATION REELLE CETTE PROCEDURE SERT A RECUPERER L'ERREUR FOURNIE PAR
			    * TABLEUPDATE POUR L'AFFICHER. ELLE EXECUTE AUSSI LE TABLEREVERT.
			    llresult = .F.
        ENDIF && llok
      ELSE
        llresult = .F.
      ENDIF && m.llresult
      USE IN (SELECT( this.alias_une_banque))
      RETURN m.llresult
    ELSE
	    IF This.vfpmou
			  INSERT INTO vfpmou VALUE (DATE(), SECONDS(), 70298, "enregistrer", This.fvfpmou, ;
			   "rien  enregistrer "+ IIF(This.ya_modif, "F", "T"), "", "", 0)
	    ENDIF && This.vfpmou
	    RETURN .T.
    ENDIF && This.ya_modif
  ENDPROC
  
  FUNCTION supprimer
    * l'image doit tre  jour
    * la suppression se fait en deux temps :
    *  1) on met  jour la vue banques_une_rw  partir de l'image (donc avec la banque 'active')
    *  2) on rend le code ngatif et on fait un tableupdate de cette vue
    LOCAL llresult, lnaccu, lccode, lcnoucode
    
    WITH This
	    this.alias_une_banque = "bs"+SYS(2015) && alias local de la vue demo!banques_un_rw    
	    lccode = this.image.code
	    lcnoucode = BINTOC( - ABS(CTOBIN( m.lccode)),2)
	    * ABS() est une scurit des fois que l'on arriverait  supprimer une banque dj
	    * supprime, elle redeviendrait valide !!!
	    SELECT 0
	    USE demo!banques_une_rw ALIAS (this.alias_une_banque)
	*!				CREATE SQL VIEW "BANQUES_UNE_RW" ; 
	*!				 AS SELECT * FROM demo!banques WHERE code = ?lccode
	    IF RECCOUNT() = 1
	      LOCAL llok, lcaccu
	      LOCAL ARRAY lterr2(1), ltparm(10)
	      REPLACE code WITH m.lcnoucode, creat WITH DATETIME()
	      * on enregistre la vue dans la table
			  llok = TABLEUPDATE(0, .F., this.alias_une_banque, lterr2)
			  * 0 : un seul enregistrement  .F. : on ne force pas en cas de conflit
			  * lterr2 tableau pour les recno()  problmes
			  IF llok
			    IF This.vfpmou
					  INSERT INTO vfpmou VALUE (DATE(), SECONDS(), 70210, "supprimer", This.fvfpmou, ;
					   "tableupdate ok "+This.image.code + " "+ ALLTRIM(this.image.nom), "", "", 0)
			    ENDIF && This.vfpmou
	        this.image.nom = "banque supprime"
	        * j'avais le choix entre reconstruire les listes ou remplacer le nom de la banque.
	        * j'ai pris le deuxime : l'oprateur a ainsi un retour sur son opration.
	        SELECT (This.alias_liste)
	        IF SEEK( This.image.code, This.alias_liste, "code")
	          REPLACE code WITH m.lcnoucode, nom WITH this.image.nom, frequence WITH -1
	        ENDIF && SEEK( .image.code, .alias_liste, "")
	        SELECT (.alias_combo)
	        LOCATE FOR code == .image.code
	        IF FOUND()
	          REPLACE code WITH m.lcnoucode, banque WITH this.image.nom
	        ENDIF && FOUND()
	        this.image.code = m.lcnoucode
	        This.ya_modif = .F.
			    llresult = .T.
			  ELSE
			    .erreur = -11
			    IF This.vfpmou
					  INSERT INTO vfpmou VALUE (DATE(), SECONDS(), 70211, "supprimer", This.fvfpmou, ;
					   "tableupdate NAK "+This.image.code + " "+ ALLTRIM(this.image.nom), "", "", 0)
			    ENDIF && This.vfpmou
			    ltparm(1) = "BANQUES"
			    STORE "" TO ltparm(2), ltparm(3), ltparm(4), ltparm(5), ltparm(6), ltparm(7)
			    * lcaccu = traitement_erreur_tableupdate( lterr2, ltparm)
			    * le tablerevert () est fait dans traitement_erreur_tableupdate
			    * DANS L'APPLICATION REELLE CETTE PROCEDURE SERT A RECUPERER L'ERREUR FOURNIE PAR
			    * TABLEUPDATE POUR L'AFFICHER. ELLE EXECUTE AUSSI LE TABLEREVERT.
			    llresult = .F.
	      ENDIF && llok
	    ELSE
	      .erreur = -12
	      llresult = .F.
	    ENDIF && m.llresult
	    USE IN (SELECT( this.alias_une_banque))
	    RETURN m.llresult
    ENDWITH  && This
  ENDPROC && supprimer
  
  FUNCTION ajouter()
    * on ajoute dans la table banque et aussi dans les listes
    * (on ne reconstruit pas ces listes)
    WITH This
      .image.code = BINTOC(0,2)
      .ya_modif = .T.
      IF .enregistrer()
        SELECT (This.alias_liste)
        APPEND BLANK
        GATHER NAME .image MEMO
        * provisoirement on ajoute aprs la ligne 'la banque n'est pas dans la liste'
        SELECT (.alias_combo)
        APPEND BLANK
        REPLACE banque WITH .image.nom, code WITH .image.code
        RETURN .T.
      ELSE
        RETURN .F.
      ENDIF && .enregistrer()
    ENDWITH  && This
  ENDFUNC &&* ajouter
  
  FUNCTION modifier()
    * on modifie dans la table banque et aussi dans les listes
    * (on ne reconstruit pas ces listes)
    WITH This
      .ya_modif = .T.
      IF .enregistrer()
        SELECT (.alias_liste)
        IF SEEK( .image.code, .alias_liste, "code")
          GATHER NAME .image MEMO
        ENDIF && SEEK( .image.code, .alias_liste, "")
        SELECT (.alias_combo)
        LOCATE FOR code == .image.code
        IF FOUND()
          REPLACE banque WITH .image.nom
        ENDIF && FOUND()
        RETURN .T.
      ELSE
        RETURN .F.
      ENDIF && .enregistrer()
    ENDWITH  && This
  ENDFUNC &&* ajouter
  
  FUNCTION chercher && cherche une banque et retourne l'image correspondante
    LPARAMETERS pucodbanque
    * on accepte un code sur 2 car en binaire (page 1252) ou une valeur numrique
    * je prcise que le code sur 2 car doit tre en 1252 car dans cette application
    * 'ancienne' la table des paiements est en 850 (DOS)
    * on pense bien  reslectionner l'alias initial
    LOCAL lnselect
    
    lnselect = SELECT(0)
    SELECT (This.alias_liste)
    * on essaie d'viter que a plante en cas d'erreur de paramtre:
    LOCATE FOR code == IIF( VARTYPE(m.pucodbanque)=="C", m.pucodbanque, ;
     IIF( VARTYPE(m.pucodbanque)=="N", BINTOC( m.pucodbanque,2), BINTOC(0,2)))
    * l'utilisation de l'index est automatique
    IF FOUND() && trouv
      SCATTER NAME This.image
      SCATTER NAME This.image_old
      SELECT (m.lnselect)
      RETURN .T.
    ELSE && pas trouv
      SCATTER NAME This.image BLANK
      SCATTER NAME This.image_old BLANK
      SELECT (m.lnselect)
      RETURN .F.
    ENDIF && FOUND()
  ENDPROC
  
  FUNCTION rechercher && cherche une banque SANS retourner l'image correspondante
    * sert surtout  vrifier les doublons lors de la saisie
    * on pense bien  reslectionner l'alias initial
    LPARAMETERS pccodbanque
    LOCAL lnselect, llresult
    
    lnselect = SELECT(0)  
    SELECT (This.alias_liste)
    LOCATE FOR code == pccodbanque && l'utilisation de l'index est automatique
    llresult = FOUND()
    SELECT (m.lnselect)    
    RETURN llresult
  ENDPROC
  
  FUNCTION positionnement_combo && selectionne la banque dans alias_combo et retourne son recno()
    LPARAMETERS pccodebq 
    * il faut absolument que pccodebq soit dans la page de code courante soit 1252.
    * la conversion du code de paiement doit se faire  l'appel
    * alias_combo n'a pas d'index
    
	  SELECT (this.alias_combo) && jme 04/01/2006
	  * j'avais fait une erreur d'analyse !
*!		  LOCATE FOR code == CPCONVERT(1252, 850, LEFT(m.pccodebq,2))
	  LOCATE FOR code == LEFT(m.pccodebq,2)
	  IF FOUND()
	    RETURN RECNO()
	  ELSE
	    GO TOP
	    RETURN 1 && aucune banque
	  ENDIF && FOUND()
  ENDPROC

  FUNCTION recherche_nom && cherche une banque par son nom SANS retourner l'image correspondante
    * sert surtout  vrifier les doublons lors de la saisie
    LPARAMETERS pcnom
    LOCAL lnlong, lcnom
    
    lcnom = UPPER(ALLTRIM(pcnom))
    lnlong = LEN(m.lcnom)
    SELECT (This.alias_liste)
    LOCATE FOR UPPER(LEFT(nom, m.lnlong)) == m.lcnom
    RETURN FOUND()
  ENDPROC
  
  FUNCTION recherche_abrev && cherche une banque par son abrviation SANS retourner l'image correspondante
    * sert surtout  vrifier les doublons lors de la saisie
    LPARAMETERS pcabrev
    LOCAL lnlong, lcabrev
    
    lcabrev = UPPER(ALLTRIM(pcabrev))
    lnlong = LEN(m.lcabrev)
    SELECT (This.alias_liste)
    LOCATE FOR UPPER(LEFT(abrev, m.lnlong)) == m.lcabrev
    RETURN FOUND()
  ENDPROC
  
  PROCEDURE calcul_frequence
    * mise  jour du champ frequence de la table banques pour pouvoir afficher
    * la liste des banques dans l'ordre du nombre d'utilisation (la plus
    * frquente d'abord) dans les combobox (par exemple)
    LOCAL lcalias1, lnaccu
    
    This.alias_paiement = "pa"+ SYS(2015)
    USE paiement ALIAS (This.alias_paiement) AGAIN SHARED IN 0
    lcalias1 = "bfr"+SYS(2015)
    USE demo!banques_calcul_frequence ALIAS (m.lcalias1) IN 0
*!		CREATE SQL VIEW "BANQUES_CALCUL_FREQUENCE" ;
*!		 AS SELECT codbanque AS code, COUNT(*) AS nombre ;
*!		  FROM paiement WHERE ISBLANK(codbanque) = .F. ;
*!		   GROUP BY 1 ORDER BY 2 DESC 
*!	  ATTENTION codbanque et donc code sont en page de code 850
    SELECT CPCONVERT(1252, 850, LEFT(code,2)) AS codepai, SUM(nombre) AS nombre ;
     FROM (m.lcalias1) GROUP BY 1 INTO CURSOR bf2_1PD0WI0OQ  && bf2_1PD0WI0OQ est un alias peu courant !
    * test : je met en clair cet alias peu utilis pour ne pas avoir  faire d'indirection
    * sur l'alias. bf2_1PD0WI0OQ = "bf2"+SYS(2015) au moment de la cration de cette mthode
    INDEX ON codepai TAG code
    SELECT (This.alias_banques)
    * on ne pose aucun verrou sur la table banques
    REPLACE ALL frequence WITH bf2_1PD0WI0OQ.nombre ;
     FOR SEEK(code, "bf2_1PD0WI0OQ", "code")
    USE IN (SELECT("bf2_1PD0WI0OQ"))
    USE IN (SELECT(m.lcalias1))
    USE IN (SELECT(This.alias_paiement))
  ENDPROC
  
  PROCEDURE liste_banques_cheques
    * liste des chque remis  une banque donne ou  toutes les banques pour une priode donne
    * Cette mthode n'est utilise (actuellement) que dans une seule form mais elle est tout de 
    * mme place dance cette classe : cela ne cote rien et si un jour on veut lancer ce
    * calcul d'une autre interface il est dj prt.
    
    LPARAMETERS pccodebq, pddebut, pdfin, pcnomxls  
    * pccodebq code de la banque C(2). Peut tre vide ou nul
    * pddebut = date dbut de la priode  lister. peut tre vide et dans ce cas 400 derniers jours
    * pdfin = date fin priode  lister. Peut tre vide et dans ce cas date d'aujourd'hui
    * pcnomxls : si non vide nom du tableau Excel cr (doit contenir le chemin relatif et l'extension).
    *            si vide, on ne cre pas de tableau excel
    * il faut faire attention aux chques diffrs
    * la date utilise est la date du rglement et non celle de la remise en banque
    * note : on tri en fonction de la banque metrice
    LOCAL lddebut, ldfin, lcalias, lccodebq
    
    * on ferme un rsulat prcdent ventuel
    IF !EMPTY(This.alias_listpai_1bq)
      USE IN (SELECT(This.alias_listpai_1bq))
    ENDIF && !EMPTY(This.alias_listpai_1bq)
    This.alias_paiement = "pa"+ SYS(2015)
    This.alias_listpai_1bq = "lc"+ SYS(2015)
    USE paiement ALIAS (This.alias_paiement) IN 0
    * la table paiement ne fait pas partie de la base de donnes demo
    * ATTENTION codbanque est en page de code 850
    lddebut = IIF(EMPTY(pddebut), DATE()-400, pddebut)
    ldfin = IIF(EMPTY(pdfin), DATE(), pdfin)
    IF ! EMPTY( m.pcnomxls)
      ERASE (m.pcnomxls)
    ENDIF && ! EMPTY( m.pcnomxls)
    lcalias = "c"+ SYS(2015)
    IF EMPTY( pccodebq) OR pccodebq == BINTOC(0,2)
      * on veut toutes les banques
      * on commence par traiter les chques ventils (un seul chque = plusieurs lignes)
      SELECT LEFT(codbanque,2) AS codbanque, codfam, "vent" AS codfactur, drgl, secondes, ;
       00000000.00+SUM(montant) AS montant, datremise, exprj, tireur, numchq ;
        FROM (This.alias_paiement) ;
         WHERE modepaim = "c" AND datmodif = {} AND datannul = {} AND pairemb="P" ;
          AND drgl BETWEEN m.lddebut AND m.ldfin ;
           GROUP BY 2, 4, 5 ORDER BY 1, 4, 5, 2 ;
            INTO CURSOR (m.lcalias)
      SELECT LEFT(codbanque,2) AS codbanque, codfam, codfactur, drgl, secondes, ;
       00000000.00+montant AS montant, datremise, exprj, tireur, numchq ;
        FROM (This.alias_paiement) ;
         WHERE modepaim = "C" AND datmodif = {} AND datannul = {} AND pairemb="P" ;
          AND drgl BETWEEN m.lddebut AND m.ldfin ;
      UNION ALL ;
       SELECT codbanque, codfam, codfactur, drgl, secondes, montant, datremise, exprj, tireur, numchq ;
        FROM (m.lcalias) ORDER BY 1, 4, 5, 2;
      INTO CURSOR (This.alias_listpai_1bq)
    ELSE
      * on veut une seule banque 
      lccodebq = CPCONVERT(850,1252, m.pccodebq) && attention  la page de code
      * on commence par traiter les chques ventils (un seul chque = plusieurs lignes)
      SELECT LEFT(codbanque,2) AS codbanque, codfam, "vent" AS codfactur, drgl, secondes, ;
       00000000.00+SUM(montant) AS montant, datremise, exprj, tireur, numchq ;
        FROM (This.alias_paiement) ;
         WHERE modepaim = "c" AND datmodif = {} AND datannul = {} AND pairemb="P" ;
          AND LEFT(codbanque,2) = m.lccodebq AND drgl BETWEEN m.lddebut AND m.ldfin ;
           GROUP BY 2, 4, 5 ORDER BY 1, 4, 5, 2 ;
            INTO CURSOR (m.lcalias)
      SELECT LEFT(codbanque,2) AS codbanque, codfam, codfactur, drgl, secondes, ;
       00000000.00+montant AS montant, datremise, exprj, tireur, numchq ;
        FROM (This.alias_paiement) ;
         WHERE modepaim = "C" AND datmodif = {} AND datannul = {} AND pairemb="P" ;
          AND LEFT(codbanque,2) = m.lccodebq AND drgl BETWEEN m.lddebut AND m.ldfin ;
      UNION ALL ;
       SELECT codbanque, codfam, codfactur, drgl, secondes, montant, datremise, exprj, tireur, numchq ;
        FROM (m.lcalias) ORDER BY 1, 4, 5, 2;
      INTO CURSOR (This.alias_listpai_1bq)
    ENDIF && EMPTY( pccodebq) OR pccodebq == BINTOC(0,2)
    IF ! EMPTY( m.pcnomxls)
      COPY TO (m.pcnomxls) TYPE XLS
    ENDIF && ! EMPTY( m.pcnomxls)
    USE IN (SELECT(This.alias_paiement))
    USE IN (SELECT(m.lcalias))
  ENDPROC
  
ENDDEFINE && CLASS banques AS base_maurice && jme 05/01/2006

